--[[
PB 3.3.2004
This Script has two parts: 
the upper one (by far the largest part) creates the setup window and its
different actions
the lower one (function t.drawspec) draws the spectrum, zooms and so on.

]]

-- Create objects
t={}
t.specnum={}
t.color={}
t.finalcolor={}
t.i=0
t.spectra={}
t.spectrum={}
t.cb={}
t.cp={}
t.cp.factor={}
t.cp.baseline={}
t.cp.linewidth={}
t.finalcp={}
t.finalcp.factor={}
t.finalcp.baseline={}
t.finalcp.linewidth={}
t.colorbgd="black"

-- Create a window with a vertical drawbox and show it
v=gui.createMainWindow()
v:setCaption("Selection Dialog")
t.frm=gui.createGrid(v,3,false)
v:setCentralWidget(t.frm)
v:show()
t.frm:show()
t.colorbutton={}
t.contourbutton={}

t.spectra=cara:getProject():getSpectra()

for id,spectrum in pairs( t.spectra ) do
  if spectrum:getDimCount()==2 then
    t.i=t.i+1       
    t.cp.factor[t.i]=2
    t.cp.baseline[t.i]=1000
    t.cp.linewidth[t.i]=1
  end
end
t.i=0

-- Draw checkboxes for each 2D
for id,spectrum in pairs( t.spectra ) do
  if spectrum:getDimCount()==2 then
    t.i=t.i+1
    t.cb[t.i]=gui.createCheckBox(t.frm,"Spectrum "..t.i.." ("..id..") : "..spectrum:getName())
    t.spectrum[t.i]=spectrum
    t.cb[t.i]:show()    
    t.colorbutton[t.i]=gui.createPushButton(t.frm,"Select Color")
    t.colorbutton[t.i]:getData().index=t.i
    t.contourbutton[t.i]=gui.createPushButton(t.frm,"Set Contour Parameters")
    t.contourbutton[t.i]:getData().index=t.i
-- Define a callback for the color selection dialogue
    t.colorbutton[t.i]:setCallback(gui.event.Clicked,
    function (self)
      t.color[self:getData().index]=dlg.selectColor()
      t.cb[self:getData().index]:setBgColor(t.color[self:getData().index]) 
    end)

    t.colorbutton[t.i]:show()
-- Define a callback for the color selection dialogue
    t.contourbutton[t.i]:setCallback(gui.event.Clicked,
    function (self)
      t.v=gui.createMainWindow()
      t.v:setCaption("Set Contour Parameters")
      t.v:getData().grid=gui.createGrid(t.v,2,false)
      t.v:setCentralWidget(t.v:getData().grid)
      t.v:show()
      t.v:getData().grid:show()      
      t.v:getData().label1=gui.createLabel(t.v:getData().grid,"Factor (1.4)")
      t.v:getData().field1=gui.createLineEdit(t.v:getData().grid)
      t.v:getData().label2=gui.createLabel(t.v:getData().grid,"Baseline (400)")
      t.v:getData().field2=gui.createLineEdit(t.v:getData().grid)
      t.v:getData().label3=gui.createLabel(t.v:getData().grid,"Linewidth (1)")
      t.v:getData().field3=gui.createLineEdit(t.v:getData().grid)
      t.v:getData().okbutton=gui.createPushButton(t.v:getData().grid,"Ok")
      t.v:getData().okbutton:getData().index=self:getData().index
      t.v:getData().cancelbutton=gui.createPushButton(t.v:getData().grid,"Cancel")
      t.v:getData().field1:setText(t.cp.factor[self:getData().index])
      t.v:getData().field2:setText(t.cp.baseline[self:getData().index])
      t.v:getData().field3:setText(t.cp.linewidth[self:getData().index])
      t.v:getData().label1:show()
      t.v:getData().label2:show()
      t.v:getData().label3:show()
      t.v:getData().field1:show()
      t.v:getData().field2:show()
      t.v:getData().field3:show()
-- Define callbacks for the buttons
      t.v:getData().cancelbutton:setCallback(gui.event.Clicked,
      function (self)
        t.v:close()
        t.v=nil
      end)
      t.v:getData().okbutton:setCallback(gui.event.Clicked,
      function (self)
        t.cp.factor[self:getData().index]=t.v:getData().field1:getText()
        t.cp.baseline[self:getData().index]=t.v:getData().field2:getText()
        t.cp.linewidth[self:getData().index]=t.v:getData().field3:getText()
        t.v:close()
        t.v=nil
      end)
      t.v:getData().okbutton:show()  
      t.v:getData().cancelbutton:show()
    end)
    t.contourbutton[t.i]:show()
  end
end

-- Peaklist 
t.peaklist=gui.createCheckBox(t.frm,"Overlay a Peaklist")
t.peaklistbox=gui.createComboBox(t.frm)
t.peaklists=cara:getProject():getPeakLists()
t.plb={}
t.pli={}
for id,pl in pairs( t.peaklists ) do
  t.plb[id]=t.peaklistbox:addItem(pl:getName())
  t.pli[id]=pl:getId()
end
t.peaklist:show()
t.peaklistbox:show()
t.colorbuttonpkl=gui.createPushButton(t.frm,"Select Color")
-- Define a callback for the color selection dialogue
t.colorbuttonpkl:setCallback(gui.event.Clicked,
  function (self)
    t.colorpkl=dlg.selectColor()
    t.peaklist:setBgColor(t.colorpkl)
  end)
t.colorbuttonpkl:show()

-- Background 
t.backgroundtext=gui.createLabel(t.frm,"Background")
t.backgroundtext:show()
t.colorbuttonbgd=gui.createPushButton(t.frm,"Select Color")
-- Define a callback for the color selection dialogue
t.colorbuttonbgd:setCallback(gui.event.Clicked,
  function (self)
    t.colorbgd=dlg.selectColor()
    t.backgroundtext:setBgColor(t.colorbgd)
  end)
t.colorbuttonbgd:show()
t.void=gui.createFrame(t.frm)
t.void:show()


-- OK Button and its function
t.okbutton=gui.createPushButton(t.frm,"Ok")
t.okbutton:show()
t.okbutton:setCallback(gui.event.Clicked,
  function (self)
    i=0
    j=0
    if t.peaklist:isChecked() then
      t.showpl=t.pli[t.peaklistbox:getCurrentItem()]
    else
      t.showpl=-1
    end
    for j=1,t.i do
      if t.cb[j]:isChecked() then
        i=i+1        
        t.specnum[i]=t.spectrum[j]:getId()
        t.finalcolor[i]=t.color[j]
        t.finalcp.factor[i]=t.cp.factor[j]
        t.finalcp.linewidth[i]=t.cp.linewidth[j]
        t.finalcp.baseline[i]=t.cp.baseline[j]
      end
    end
    v:close()
    t.drawspec(i, t.specnum, t.finalcolor ,t.showpl, t.colorpkl, t.finalcp)
  end )

-- Function for drawing of a peaklist

function t.drawpklst(cnvas, contplot, pklcolor, peaklst_no, width, height)
  cnvas:setPen(pklcolor,1)
  t.peaklst=cara:getProject():getPeakList(peaklst_no)
  t.peakcoo={}
  t.peakcoopts={}
  t.assign={}
  for peakindx, peakobj in pairs(t.peaklst:getPeaks()) do
    t.peakcoo[1],t.peakcoo[2] =peakobj:getPos()
    t.peakcoopts[1]=contplot:toPoint(1,0,width,t.peakcoo[1])
    t.peakcoopts[2]=contplot:toPoint(2,0,height,t.peakcoo[2])
    cnvas:drawLine(t.peakcoopts[1]-5,t.peakcoopts[2],t.peakcoopts[1]+5,t.peakcoopts[2])
    cnvas:drawLine(t.peakcoopts[1],t.peakcoopts[2]-5,t.peakcoopts[1],t.peakcoopts[2]+5)
    if peakobj:getAssig()~=nil then
      t.assign[1],t.assign[2]=peakobj:getAssig()
    else
      t.assign[1],t.assign[2]=-1,-1
    end
    if t.assign[1]~=-1 and t.assign[2]~=-1 then
      cnvas:drawText(t.peakcoopts[1]+7,t.peakcoopts[2]+5,t.assign[1].." "..t.assign[2])
    else
      cnvas:drawText(t.peakcoopts[1]+7,t.peakcoopts[2]+5,peakobj:getId())
    end
  end
  return 1
end

-- The actual drawing function
function t.drawspec(imax, specnumlist, colors, peaklst, colorpeaklst, cp)

-- Initialize lots of stuff 
w=gui.createWidget()
w:setCaption("Viewer for multiple NMR Spectra")
w:setBgColor(t.colorbgd)
w:show()
w:getData().spec={}
w:getData().color={}
w:getData().buf={}
w:getData().c={}

-- Get colors & spectra
for ii=1,imax do
  w:getData(colors[ii]).color[ii]=colors[ii]  
  w:getData().spec[ii]=cara:getProject():getSpectrum(specnumlist[ii])
end

-- Determine max, min ppm
w:getData().ppmmax1,w:getData().ppmmin1=w:getData().spec[1]:getPpmRange(1)
w:getData().ppmmin2,w:getData().ppmmax2=w:getData().spec[1]:getPpmRange(2)

-- Write Buffers
for ii=1,imax do
  w:getData().buf[ii]=w:getData().spec[ii]:getPlanePpm(1,2,w:getData().ppmmax1,w:getData().ppmmin1,w:getData().ppmmax2,w:getData().ppmmin2)
  w:getData().c[ii]=dlg.createContour(w:getData().buf[ii])
  w:getData().c[ii]:setPosColor(w:getData().color[ii])
  w:getData().c[ii]:setNegColor(w:getData().color[ii])
  w:getData().c[ii]:setLineWidth(cp.linewidth[ii])
  w:getData().c[ii]:setParams(cp.factor[ii],cp.baseline[ii])
end

-- Draw and Redraw
w:setCallback(gui.event.Paint,
  function (self, p)
     local width,height = self:getSize()
     for ii=1,imax do
       p:drawContour( self:getData().c[ii],0,0,width,height)
     end
     if peaklst>0 then
       t.out=t.drawpklst(p,self:getData().c[1],colorpeaklst,peaklst, width, height)
     end
  end )

w:setCallback(gui.event.MousePressed,
  function (self, x,y,left,mid,right,shift,ctrl,alt)
     local width,height = self:getSize()
     if ctrl==true and shift==true then
       self:getData().ppmmin1=self:getData().c[1].toPpm(self:getData().c[1],1,0,width,x)
       self:getData().ppmmin2=self:getData().c[1].toPpm(self:getData().c[1],2,0,height,y)
     end
  end )

w:setCallback(gui.event.MouseReleased,
  function (self, x,y,left,mid,right,shift,ctrl,alt)
     local width,height = self:getSize()
     if ctrl==true and shift==true then
       self:getData().ppmmax1=self:getData().c[1].toPpm(self:getData().c[1],1,0,width,x)
       self:getData().ppmmax2=self:getData().c[1].toPpm(self:getData().c[1],2,0,height,y)

       if self:getData().ppmmax1<self:getData().ppmmin1 then
         self:getData().temp=self:getData().ppmmax1
         self:getData().ppmmax1=self:getData().ppmmin1
         self:getData().ppmmin1=self:getData().temp
       end 
       if self:getData().ppmmax2>self:getData().ppmmin2 then
         self:getData().temp=self:getData().ppmmax2
         self:getData().ppmmax2=self:getData().ppmmin2
         self:getData().ppmmin2=self:getData().temp
       end 
       for ii=1,imax do
         self:getData().buf[ii]=self:getData().spec[ii]:getPlanePpm(1,2,self:getData().ppmmax1,self:getData().ppmmin1,self:getData().ppmmax2,self:getData().ppmmin2)
         self:getData().c[ii]=dlg.createContour(w:getData().buf[ii])
         self:getData().c[ii]:setPosColor(w:getData().color[ii])
         self:getData().c[ii]:setNegColor(w:getData().color[ii])
         self:getData().c[ii]:setLineWidth(cp.linewidth[ii])
         self:getData().c[ii]:setParams(cp.factor[ii],cp.baseline[ii])
       end
       self:update()
     end
  end )


w:setCallback(gui.event.KeyReleased,
  function (self, keyCode,text,shift,ctrl,alt)
     local width,height = self:getSize()
     if keyCode==4112 then
       self:getData().ppmmax1,self:getData().ppmmin1=self:getData().spec[1]:getPpmRange(1)
       self:getData().ppmmin2,self:getData().ppmmax2=self:getData().spec[1]:getPpmRange(2)
       for ii=1,imax do
         self:getData().buf[ii]=self:getData().spec[ii]:getPlanePpm(1,2,self:getData().ppmmax1,self:getData().ppmmin1,self:getData().ppmmax2,self:getData().ppmmin2)
         self:getData().c[ii]=dlg.createContour(w:getData().buf[ii])
         self:getData().c[ii]:setPosColor(w:getData().color[ii])
         self:getData().c[ii]:setNegColor(w:getData().color[ii])
         self:getData().c[ii]:setLineWidth(cp.linewidth[ii])
         self:getData().c[ii]:setParams(cp.factor[ii],cp.baseline[ii])
       end
       self:update()
     end
  end )

w:update()
end
